#include <svn/ra/callbacks.hh>
#include <svn/exception.hh>

using namespace boost;

namespace svn {
namespace ra {

svn_ra_callbacks_t Callbacks::rawCallbacks = {
    &open_tmp_file,
    &get_authenticator,
    &get_wc_prop,
    &set_wc_prop,
    &push_wc_prop,
    &invalidate_wc_props
};

svn_error_t *Callbacks::open_tmp_file(apr_file_t **fp, void *callback_baton) {
    const Callbacks *thisCallbacks =
        reinterpret_cast<const Callbacks*>(callback_baton);
    *fp = thisCallbacks->openTmpFile().get();
    return SVN_NO_ERROR;
}

svn_error_t *Callbacks::get_authenticator(void **authenticator,
        void **auth_baton, enum svn_ra_auth_method method,
        void *callback_baton, apr_pool_t *pool) {
    abort();
}

svn_error_t *Callbacks::get_wc_prop(void *baton, const char *relpath,
        const char *name, const svn_string_t **value, apr_pool_t *pool) {
    abort();
}

svn_error_t *Callbacks::set_wc_prop(void *baton, const char *relpath,
        const char *name, const svn_string_t *value, apr_pool_t *pool) {
    abort();
}

svn_error_t *Callbacks::push_wc_prop(void *baton, const char *path,
        const char *name, const svn_string_t *value, apr_pool_t *pool) {
    abort();
}

svn_error_t *Callbacks::invalidate_wc_props(void *baton, const char *path,
        const char *name, apr_pool_t *pool) {
    abort();
}

}
}
